// 002 u_c_web_server_2
// 13 may 2005

// -- (C) Felix John COLIBRI 2004
// -- documentation: http://www.felix-colibri.com

(*$r+*)

unit u_c_web_server_2;
  interface
    uses u_c_basic_object
        , u_c_byte_buffer
        , u_c_server_socket_4
        ;

    type c_web_server= Class;
         t_po_web_server_event= Procedure(p_c_web_server: c_web_server) of object;

         c_web_server= class(c_basic_object)
                         m_c_server_socket: c_server_socket;

                         m_trace_web_server: Boolean;
                         m_site_path: String;

                         Constructor create_web_server(p_name, p_site_path: String);

                         procedure start_web_server(p_port: Integer);
                         procedure close_web_server;

                         Destructor Destroy; Override;
                       end; // c_web_server

  implementation
    uses Classes, SysUtils, u_c_display, u_types_constants
        , u_c_http_server_client_socket
        ;

    // -- c_web_server

    Constructor c_web_server.create_web_server(p_name, p_site_path: String);
      begin
        Inherited create_basic_object(p_name);
        m_site_path:= p_site_path;

        // -- specify which c_server_client_sockt Class should be created
        m_c_server_socket:= c_server_socket.create_server_socket('server',
            c_http_server_client_socket);
        // -- back link from c_server_sockt to c_web_server    
        m_c_server_socket.m_c_parent_ref:= Self;
      end; // create_web_server

    procedure c_web_server.start_web_server(p_port: Integer);
      begin
        with m_c_server_socket do
        begin
          m_trace_socket:= m_trace_web_server;

          wsa_startup;
          create_win_socket;
          wsa_select;
          do_bind_win_socket(p_port);
          do_listen_to_client(k_default_listen_queue_size)
        end; // with m_c_server_socket
      end; // start_web_server

    procedure c_web_server.close_web_server;
      begin
        m_c_server_socket.do_close_win_socket;
      end; // close_web_server

    Destructor c_web_server.Destroy;
      begin
        close_web_server;
        m_c_server_socket.Free;

        Inherited;
      end; // Destroy

    begin // u_c_web_server
    end. // u_c_web_server
