// 002 u_web_server
// 09 jan 97

// -- (C) Felix John COLIBRI 2004
// -- documentation: http://www.felix-colibri.com

(*$r+*)

unit u_web_server;
  interface
    uses Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs
        , StdCtrls
        , ExtCtrls, ComCtrls
        , u_c_base_socket_4

        , u_c_server_socket_4
        , u_c_web_server_2
        ;

    type TForm1= class(TForm)
    Panel1: TPanel;
    edit_port: TEdit;
    go: TButton;
    clear_: TButton;
    create_: TPanel;
    wsa_startup_: TPanel;
    Socket_: TPanel;
    wsa_async_select_: TPanel;
    bind_: TPanel;
    listen_: TPanel;
    close_socket_: TPanel;
    exit_: TButton;
    go_2_: TButton;
    Memo1: TMemo;
                   procedure wsaStartup_Click(Sender: TObject);
                   procedure Socket_Click(Sender: TObject);
                   procedure wsaAsyncSelect_Click(Sender: TObject);
                   procedure CloseSocket_Click(Sender: TObject);
                   procedure Bind_Click(Sender: TObject);
                   procedure Listen_Click(Sender: TObject);
                   procedure goClick(Sender: TObject);
                   procedure FormCreate(Sender: TObject);
    procedure create_Click(Sender: TObject);
    procedure clear_Click(Sender: TObject);
    procedure exit_Click(Sender: TObject);
    procedure go_2_Click(Sender: TObject);
                   private
                   public
                 end;

    var Form1: TForm1;

  implementation
    uses
        u_c_log, u_c_display, u_display_hex_2, u_types_constants
        , u_file
      ;

    {$R *.DFM}

 
    const k_site_path= '..\web_server\_site\';
    var g_c_web_server: c_web_server= Nil;

    procedure set_panel_color(p_c_panel: tPanel; p_color: Integer);
      begin
        p_c_panel.Color:= p_color;
        Application.ProcessMessages;
      end; // set_panel_color

    // -- user actions

    procedure TForm1.FormCreate(Sender: TObject);
      begin
        initialize_display(Memo1.Lines);
        initialize_default_log;

        set_panel_color(create_, clLime);
        set_panel_color(wsa_startup_, clRed);
        set_panel_color(socket_, clRed);
        set_panel_color(bind_, clRed);
        set_panel_color(wsa_async_select_, clRed);
        set_panel_color(listen_, clRed);
      end; // FormCreate

    procedure TForm1.clear_Click(Sender: TObject);
      begin
        clear_display;
      end; // clear_Click

    procedure TForm1.create_Click(Sender: TObject);
      begin
        g_c_web_server:= c_web_server.create_web_server('web_server', k_site_path);

        with g_c_web_server.m_c_server_socket do
        begin
          m_trace_socket:= True;
        end; // with g_c_web_server.m_c_server_socket

        set_panel_color(create_, clRed);
        set_panel_color(wsa_startup_, clLime);
      end; // create_Click

    procedure TForm1.wsaStartup_Click(Sender: TObject);
      begin
        // -- link the events
        with g_c_web_server.m_c_server_socket do
        begin
          wsa_startup;
          display_wsa_data;
        end; // with g_c_web_server.m_c_server_socket

        set_panel_color(wsa_startup_, clRed);
        set_panel_color(socket_, clLime);
      end; // wsaStartup

    procedure TForm1.Socket_Click(Sender: TObject);
      begin
        g_c_web_server.m_c_server_socket.create_win_socket;

        set_panel_color(socket_, clRed);
        set_panel_color(wsa_async_select_, clLime);
      end; // Socket_clic

    procedure TForm1.wsaAsyncSelect_Click(Sender: TObject);
      begin
        g_c_web_server.m_c_server_socket.wsa_select;

        set_panel_color(wsa_async_select_, clRed);
        set_panel_color(bind_, clLime);
      end; // wsaAsyncSelect

    procedure TForm1.Bind_Click(Sender: TObject);
        // -- assigns an address to the socket
      begin
        g_c_web_server.m_c_server_socket.do_bind_win_socket(StrToInt(edit_port.Text));

        set_panel_color(bind_, clRed);
        set_panel_color(listen_, clLime);
      end; // bind_Click

    procedure TForm1.Listen_Click(Sender: TObject);
      begin
        g_c_web_server.m_c_server_socket.do_listen_to_client(k_default_listen_queue_size);

        set_panel_color(listen_, clRed);
      end; // Listen_Click

    procedure TForm1.CloseSocket_Click(Sender: TObject);
      begin
        g_c_web_server.m_c_server_socket.do_close_win_socket;
      end; // CloseSocket_Click

    procedure TForm1.goClick(Sender: TObject);
      begin
        create_Click(Self);
        wsaStartup_Click(self);
        Socket_Click(self);
        wsaAsyncSelect_Click(self);
        Bind_Click(self);
        Listen_Click(self);

        set_panel_color(create_, clRed);
        set_panel_color(wsa_startup_, clRed);
        set_panel_color(socket_, clRed);
        set_panel_color(bind_, clRed);
        set_panel_color(wsa_async_select_, clRed);
        set_panel_color(close_socket_, clLime);
      end; // goClick

    procedure TForm1.go_2_Click(Sender: TObject);
      begin
        g_c_web_server:= c_web_server.create_web_server('web_server', k_site_path);
        with g_c_web_server do
        begin
          m_trace_web_server:= True;
          start_web_server(StrToInt(edit_port.Text));
        end;
        set_panel_color(create_, clRed);
        set_panel_color(wsa_startup_, clRed);
        set_panel_color(socket_, clRed);
        set_panel_color(bind_, clRed);
        set_panel_color(wsa_async_select_, clRed);
        set_panel_color(close_socket_, clLime);
      end; // go_2_Click

    procedure TForm1.exit_Click(Sender: TObject);
      begin
        g_c_web_server.Free;
        g_c_display.Free;
        Close;
      end; // exit_Click

    end.
